Array.prototype.random = function () {
    return this[Math.floor((Math.random()*this.length))];
}

var modul2 = {
    datas: {
        jump2: undefined,
        line: [[0,0],[0,240]]
    },

    thermometer: {
        initialize() {
            var container = sm.element('thermometer-container');
            var thermometer = sm.element('thermometer')

            if (typeof container._thermometer == "undefined") {
                container._thermometer = thermometer;
                thermometer._dragging = false;
                thermometer._container = container;
    
                thermometer.addEventListener('mousedown', modul2.thermometer.drag);
                container.addEventListener('mouseup', modul2.thermometer.undrag);
                container.addEventListener('mousemove', modul2.thermometer.mousemove);

                container._buckets = eval(container.getAttribute('sm-buckets'));
                console.log(container._buckets);

                modul2.thermometer.set(19);
            }
        },

        set(temperature) {
            var fluid = sm.element('thermometer-fluid');
            fluid.style.height = (temperature / 100 * 44 + 15) + '%';

            var line = sm.element('thermometer-line');
            if (line != undefined) {
                line.style.bottom = (temperature / 100 * 35.4 + 30.6) + '%';
            }
            line = sm.element('thermometer-vline');
            if (line != undefined) {
                line.style.left = (temperature / 100 * 176 + 83) + 'px';
            }
        },

        drag(event) {
            var thermometer = this;
            var container = thermometer._container;

            var rect = thermometer.getBoundingClientRect();
            thermometer._dragX = event.clientX - rect.left + thermometer.offsetLeft;
            thermometer._dragY = event.clientY - rect.top + thermometer.offsetTop;
            thermometer._startX = thermometer.offsetLeft + rect.width/2;
            thermometer._startY = thermometer.offsetTop;

            thermometer._dragging = true;
            container.classList.add('dragging');
        },

        locate(x, y) {
            var container = sm.element('thermometer-container');
            var thermometer = sm.element('thermometer');

            var rect = container.getBoundingClientRect();
            thermometer.style.left = (x / rect.width * 100).toFixed(2) + '%';
            thermometer.style.top = (y / rect.height * 100).toFixed(2) + '%';
        },

        mousemove(event) {
            var container = this;
            var thermometer = container._thermometer;

            /* Wird der Thermometer gerade verschoben? */
            if (thermometer._dragging) {
                var rect = container.getBoundingClientRect();
                var dx = event.clientX - rect.left - thermometer._dragX;
                var dy = event.clientY - rect.top - thermometer._dragY;
                var x = thermometer._startX + dx;
                var y = thermometer._startY + dy;

                thermometer._x = x;
                thermometer._y = y;

                var fang = false;

                if (y > 10) {
                    for (i = 0; i < container._buckets.length; i++) {
                        var bucket = container._buckets[i];
                        var pos = bucket.pos * (rect.width - 100) + 50;
                        if (x > pos - 50 && x < pos + 50) {
                            modul2.thermometer.set(bucket.theta);
                            thermometer._fangX = pos;
                            thermometer._fangY = 45;
                            fang = true;
                            container.classList.add('fang');
                            break;
                        }
                    }
                } else {
                    fang = false;
                }

                if (fang == false) {
                    container.classList.remove('fang');
                    modul2.thermometer.set(19);
                    thermometer._fangX = x;
                    thermometer._fangY = y;
                }

                modul2.thermometer.locate(x, y);
            }
        },

        undrag(event) {
            var container = this;

            modul2.thermometer.locate(container._thermometer._fangX, container._thermometer._fangY);

            container._thermometer._dragging = false;
            container.classList.remove('dragging');
        }
    },

    aufgabe: {
        calcngvk(){
            var result = (parseFloat(elem('nluftgvk').value) * Math.pow(10, parseFloat(elem('nluftgvk-exp').value)) * parseFloat(elem('nluftgvk-volume').value)).toExponential().split('e+');

            var expform = result[0].replace('.', ',').slice(0, 4) + '&centerdot;10<sup>' + result[1] + '</sup>';
            elem('nluftgvk-ergebnis').innerHTML = expform;
            elem('nluftgvk-ergebnis2').innerHTML = expform;
        },
        calcnethanol(){
            var result = (parseFloat(elem('nethanol').value) * Math.pow(10, parseFloat(elem('nethanol-exp').value)) * parseFloat(elem('nethanol-volume').value)).toExponential().split('e+');

            var expform = result[0].replace('.', ',').slice(0, 4) + '&centerdot;10<sup>' + result[1] + '</sup>';
            elem('nethanol-ergebnis').innerHTML = expform;
            elem('nethanol-ergebnis2').innerHTML = expform;
            elem('nethanol-ergebnis3').innerHTML = expform;

            var nluft = parseFloat(elem('nluftgvk').value) * Math.pow(10, parseFloat(elem('nluftgvk-exp').value)) * parseFloat(elem('nluftgvk-volume').value);
            var nethanol = parseFloat(elem('nethanol').value) * Math.pow(10, parseFloat(elem('nethanol-exp').value)) * parseFloat(elem('nethanol-volume').value);
            var result = (nethanol / (nethanol + nluft)).toExponential().split('e-');
            var expform = result[0].replace('.', ',').slice(0, 4) + '&centerdot;10<sup>-' + result[1] + '</sup>';
            elem('ergebnis').innerHTML = expform;
        }
    },



    mth_training: {
        data: [[60,159,66],[70,168,70],[80,178,77],[90,184,87],[100,187,104]],
        g1: 0,
        g2: 0,

        setWeights(g1, g2) {
            modul2.mth_training.g1 = g1;
            modul2.mth_training.g2 = g2;

            elem('g2-line').style.top = (-g2 / 2 * 50) + '%';
            elem('g1-line').style.left = (g1 / 2 * 50) + '%';

            elem('g1-value').innerHTML = g1.toFixed(2).replace('.',',');
            elem('g2-value').innerHTML = g2.toFixed(2).replace('.',',');

            var correct = true;
            data = modul2.mth_training.data;
            for (var i = 0; i < 5; i++) {
                var element = elem('data-' + i);
                var value = data[i][1] * g1 + data[i][2] * g2;
                element.style.left = data[i][0] / 120 * 100 + '%';
                element.style.top = (1 - value / 120.0) * 100 + '%';

                if (value > data[i][0] + 10 || value < data[i][0] - 10) {
                    correct = false;
                }
            }

            if (correct) {
                elem('bereich').style.filter = "hue-rotate(110deg) brightness(1.2)";
            } else {
                elem('bereich').style.filter = "hue-rotate(0deg)";
            }

            if (elem('regler').classList.contains('active')) {
                if (correct) {
                    sm.stepBox.enable(elem('stepbox'));
                    elem('regler-step').removeAttribute('sm-disablenext');
                } else {
                    sm.stepBox.disable(elem('stepbox'));
                }
            }
        },

        update() {
            var g1 = parseFloat(elem('g1').value);
            var g2 = parseFloat(elem('g2').value);

            modul2.mth_training.setWeights(g1, g2);
        },

        probe(i) {
            elem('w-'+ i).innerHTML = (parseFloat(elem('g-' + i).value) * 0.03 + parseFloat(elem('t-' + i).value) * 0.92).toFixed(1).replace('.',',');
        }
    },


    
    training: {
        loaded: false,
        initialized: false,
        dataA: [],
        dataB: [],
        dataTraining: [],
        nn: undefined,
        lowestError: 1,
        errorMark: 0,
        steps: 0,
        properties: [],
        trainingInitialized: false,

        load() {
            if (!modul2.training.loaded) {
                var script  = document.createElement('script'); 
                script.src  = 'Teil2/lib/Trainingsdaten.js';
                script.type = 'text/javascript';
                script.defer = true;
                script.onload = modul2.training.initializeGraphs;
                
                document.getElementsByTagName('head').item(0).appendChild(script);
                
                modul2.training.loaded = true;
            }
        },

        initializeGraphs() {
            var plotA = elem('plot-a');
            var plotB = elem('plot-b');

            if (max) {
                modul2.training.properties.push({name: 'Maximum', symbol: 'MAX', unit: 'k&Omega;'});
            }
            if (min) {
                modul2.training.properties.push({name: 'Minimum', symbol: 'MIN', unit: 'k&Omega;'});
            }
            if (slope) {
                modul2.training.properties.push({name: 'Steigung', symbol: 'ST', unit: 'k&Omega;/s'})
            }
            if (mean) {
                modul2.training.properties.push({name: 'Mittelwert', symbol: 'MW', unit: 'k&Omega;'})
            }

            var yminA = NaN;
            var ymaxA = NaN;
            var yminB = NaN;
            var ymaxB = NaN;
            
            for(var i = 0; i < training_data.length; i++) {
                var yA = training_data[i].inputs[0];
                var yB = training_data[i].inputs[1];
                training_data[i].outputs[0] = training_data[i].outputs[0] / 40.0;

                if (!(yminA < yA)) {
                    yminA = yA;
                }
                if (!(ymaxA > yA)) {
                    ymaxA = yA;
                }
                if (!(yminB < yB)) {
                    yminB = yB;
                }
                if (!(ymaxB > yB)) {
                    ymaxB = yB;
                }
                modul2.training.dataA.push([training_data[i].outputs[0] * 40.0, yA * 0.001]);
                modul2.training.dataB.push([training_data[i].outputs[0] * 40.0, yB * 0.001]);
                modul2.training.dataTraining.push([training_data[i].outputs[0], 0.5]);
            }

            modul2.training.minA = yminA;
            modul2.training.minB = yminB;
            modul2.training.maxA = ymaxA;
            modul2.training.maxB = ymaxB;

            for (var i = 0; i < training_data.length; i++) {
                training_data[i].inputs[0] = (training_data[i].inputs[0] - yminA) / (ymaxA - yminA);
                training_data[i].inputs[1] = (training_data[i].inputs[1] - yminB) / (ymaxB - yminB);
            }

            plotA.setAttribute('sm-ymin', (Math.floor(yminA * 0.001 / 250) * 250).toFixed(0));
            plotA.setAttribute('sm-ymax', (Math.ceil(ymaxA * 0.001 / 250) * 250).toFixed(0));
            plotA.setAttribute('sm-yname', modul2.training.properties[0].name);
            plotA.setAttribute('sm-ysymbol', modul2.training.properties[0].symbol);
            plotA.setAttribute('sm-yunit', modul2.training.properties[0].unit);
            plotB.setAttribute('sm-ymin', (Math.floor(yminB * 0.001 / 250) * 250).toFixed(0));
            plotB.setAttribute('sm-ymax', (Math.ceil(ymaxB * 0.001 / 250) * 250).toFixed(0));
            plotB.setAttribute('sm-yname', modul2.training.properties[1].name);
            plotB.setAttribute('sm-ysymbol', modul2.training.properties[1].symbol);
            plotB.setAttribute('sm-yunit', modul2.training.properties[1].unit);
            elem('name-a').innerHTML =  modul2.training.properties[0].name;
            elem('name-b').innerHTML = modul2.training.properties[1].name;

            sm.plot.parse(plotA);
            sm.plot.parse(plotB);
        },

        initializeTraining() {
            if (modul2.training.trainingInitialized) {
                return;
            } else {
                modul2.training.trainingInitialized = true;
            }

            var data = modul2.training.dataTraining;
            var datasElement = elem('datas');

            for (var i = 0; i < data.length; i++) {
                var pointElement = document.createElement('div');
                pointElement.classList.add('sm-datapoint');
                datasElement.append(pointElement);

                data[i].point = pointElement;
            }
            
            var nn = new NeuralNetwork(2, [20, 10, 50], 1);
            nn.setActivationFunction(sigmoid);
            nn.setLearningRate(0.05);
            modul2.training.nn = nn;

            modul2.training.updateTrainingData();
        },

        startTraining() {
            modul2.training.interval = setInterval(modul2.training.train, 35);
            elem('button-start').disabled = true;
        },

        train() {
            modul2.training.steps += 10;
            for (var i = 0; i < 100; i++) {
                var sample = training_data.random();
                modul2.training.nn.train(sample.inputs, sample.outputs);
            }
            modul2.training.updateTrainingData();

            if (modul2.training.steps >= 10000) {
                clearInterval(modul2.training.interval);
                elem('button-start').disabled = false;
            }
        },

        updateTrainingData() {
            var data = modul2.training.dataTraining;
            var nn = modul2.training.nn;
            var error = 0;

            elem('steps').innerHTML = modul2.training.steps;

            for (var i = 0; i < data.length; i++) {
                data[i][1] = nn.predict(training_data[i].inputs);
                var element = data[i].point;
                var delta = data[i][1] - data[i][0];
                error += delta * delta;
                element.style.left = data[i][0] * 100 + '%';
                element.style.top = (1 - data[i][1]) * 100 + '%';
            }
            error = Math.pow(error / training_data.length, 0.5);

            if (error < modul2.training.lowestError) {
                elem('error').innerHTML = (error * 100).toFixed(2);
                modul2.training.lowestError = error;
            }

            if (modul2.training.errorMark == 0) {
                if (modul2.training.lowestError <= 0.1) {
                    elem('range-1').innerHTML = '10%-Fehlertoleranz erstmals unterschritten nach ' + modul2.training.steps + ' Schritten';
                    modul2.training.errorMark += 1;
                }
            } else if (modul2.training.errorMark == 1) {
                if (modul2.training.lowestError <= 0.05) {
                    elem('range-2').innerHTML = '5%-Fehlertoleranz erstmals unterschritten nach ' + modul2.training.steps + ' Schritten';
                    modul2.training.errorMark += 1;
                }
            }
        },

        initializeExercise() {
            elem('title-a').innerHTML = modul2.training.properties[0].name + ' in [' + modul2.training.properties[0].unit + ']';
            elem('title-b').innerHTML = modul2.training.properties[1].name + ' in [' + modul2.training.properties[1].unit + ']';
        },

        doPrediction() {
            var minA = modul2.training.minA;
            var minB = modul2.training.minB;
            var maxA = modul2.training.maxA;
            var maxB = modul2.training.maxB;

            var valueA = (1000 * parseFloat(elem('value-a').value) - minA) / (maxA - minA);
            var valueB = (1000 * parseFloat(elem('value-b').value) - minB) / (maxB - minB);
            var prediction = modul2.training.nn.predict([valueA, valueB]) * 40;

            console.log(prediction);

            elem('prediction').value = prediction.toFixed(0);
        }
    }
}